require "defines"
require "util"



--Const variables
local ITEM_COLSPAN = 7
local BIGGEST_INV = 60 -- currently player inventory



--
-- Script Events
--
-- [[
game.oninit(function()

end)

game.onload(function()
	if onsave == nil and game.player.gui.top.tm_flow ~= nil then
		activate()
	end
end)

game.onsave(function()
	onsave = true
end)
--]]



--
-- Game Events
--
function activate()
	game.onevent(defines.events, function(event)
		if glob.printevents and event.name ~= defines.events.ontick then
			printevent(event)
		end
		if event.name == defines.events.ontick then
			--ontick(event)
		elseif event.name == defines.events.onguiclick then
			onguiclick(event)
		--elseif event.name == defines.events.onentitydied then
			--onentitydied(event)
		--elseif event.name == defines.events.onpickedupitem then
			--onpickedupitem(event)
		elseif event.name == defines.events.onbuiltentity then
			onbuiltentity(event)
		--elseif event.name == defines.events.onsectorscanned then
			--onsectorscanned(event)
		--elseif event.name == defines.events.onplayermineditem then
			--onplayermineditem(event)
		elseif event.name == defines.events.onputitem then
			onputitem(event)
		--elseif event.name == defines.events.onshiplandingstart then
			--onshiplandingstart(event)
		--elseif event.name == defines.events.onpreplayermineditem then
			--onpreplayermineditem(event)
		--elseif event.name == defines.events.onchunkgenerated then
			--onchunkgenerated(event)
		end
	end)
end

--
-- Game Event Functions
--
function printevent(event)
	local name = get_key_for_value( defines.events, event.name )
	if name == nil then name = "Unknown Event" end
	game.player.print(name .. ":" )
	local level = 1
	if event.itemstack or event.area or event.position then level = 3 end
  if event.element then
    game.player.print( serpent.line(event,{maxlevel = level}) .. ", Element name:" .. event.element.name )
  else
    game.player.print( serpent.line(event,{maxlevel = level}) )
  end
end

function ontick(event)
end

function onguiclick(event)
	if event.element.name == "tm_b" then
		tm_toggle()
	elseif event.element.name == "tm_settings_b" then
		show_settings()
	elseif event.element.name == "tm_tools_b" then
		show_tool_settings()
	elseif event.element.name == "tm_items_b" then
		show_items()
	elseif event.element.name == "toolbar_b" then
		show_toolbar()
    
	elseif event.element.name == "res_mode" then -- Tool modes
		glob.toolmode = "resource"
		updateDiodes()
	elseif event.element.name == "tele_mode" then
		glob.toolmode = "teleport"
		updateDiodes()
	elseif event.element.name == "clean_mode" then
		glob.toolmode = "cleaner"
		updateDiodes()
	elseif event.element.name == "fill_mode" then
		glob.toolmode = "filler"
		updateDiodes()
    
	elseif event.element.name == "avoid" then
		glob.teleport.avoid = not glob.teleport.avoid
		event.element.caption = glob.teleport.avoid and "ON" or "OFF"
    
  elseif event.element.name == "restoretoggle" then
		toggle_restore()
	elseif event.element.name == "eventtoggle" then
		toggle_events()
	elseif event.element.name == "timetoggle" then
		toggle_time()
	elseif event.element.name == "clearall" then
		clearinvs()
	elseif event.element.name == "getalltech" then
		game.player.force.researchalltechnologies()
    
	elseif event.element.name == "spawn_tool" then
		game.player.insert({name="mjollnir", count=32})
    
	elseif event.element.name == "iron-ore" then -- Resource Modes
		tmgui = game.player.gui.top.tm_flow
		glob.oretype = event.element.name
		event.element.caption = "ON"
		tmgui.tmframe.tools_t["copper-ore"].caption = "OFF"
		tmgui.tmframe.tools_t["coal"].caption = "OFF"
	elseif event.element.name == "copper-ore" then
		tmgui = game.player.gui.top.tm_flow
		glob.oretype = event.element.name
		event.element.caption = "ON"
		tmgui.tmframe.tools_t["iron-ore"].caption = "OFF"
		tmgui.tmframe.tools_t["coal"].caption = "OFF"
	elseif event.element.name == "coal" then
		tmgui = game.player.gui.top.tm_flow
		glob.oretype = event.element.name
		event.element.caption = "ON"
		tmgui.tmframe.tools_t["iron-ore"].caption = "OFF"
		tmgui.tmframe.tools_t["copper-ore"].caption = "OFF"
  elseif string.find(event.element.name, "fc%-") then -- Fill Selected
    local name = string.gsub(event.element.name, "fc%-", "")
    
    if name == "cancel" then -- cancel fill
      glob.fillselected = nil
      
    elseif name == "list" then --call itemlist
      glob.tab_active = "items"
      if game.player.gui.top.tm_flow.tmframe then tm_toggle() end
      tm_toggle()
      if glob.active_group == nil then glob.active_group = "item" end
      add_itemlist(glob.active_group)
      
    else -- shortcut insertion
      if glob.fillselected and glob.fillselected.valid then
        glob.fillselected.insert({name = name, count = game.itemprototypes[name].stacksize * BIGGEST_INV})
      end
      glob.fillselected = nil
    end
    
		centerPopUp() -- Clears GUI

  elseif string.find(event.element.name, "ss%-") then -- Stack size
    local action = string.gsub(event.element.name, "ss%-", "")
    if action == "box" then return end -- click on text field
    if action == "items" or action == "stacks" then
      local box = game.player.gui.center.popup.tbl["ss-box"]
      local value = tonumber(box.text)
      if value then
        if action == "stacks" then
          value = value * game.itemprototypes[glob.itemname].stacksize
        end
        insertstack(value)
      end
    end
    centerPopUp() -- Clears GUI

  elseif string.find(event.element.name, "tp%-") then -- textprompt
    local action = string.gsub(event.element.name, "tp%-", "")
    if action == "box" then return end -- click on text field
    if action == "find" then
      showItemSearch(game.player.gui.center.popup.tbl["tp-box"].text)
    end
    centerPopUp() -- Clears GUI
    
	elseif string.find(event.element.name, "tab_") then
    if event.element.name == "tab_search" then
      centerPopUp("search")
    else
      add_itemlist( string.gsub(event.element.name, "tab_", "") )
    end
	elseif string.find(event.element.name, "insert_") then
    local itemname = string.gsub(event.element.name, "insert_", "")
    if glob.fillselected == nil then -- No selection to fill. 
      centerPopUp("insertion", itemname) --stacksize question popup.
    elseif glob.fillselected.valid then -- Filling selection. Item picked from list.
      glob.fillselected.insert({name = itemname, count = game.itemprototypes[itemname].stacksize * BIGGEST_INV})
      glob.fillselected = nil
      if game.player.gui.top.tm_flow.tmframe then tm_toggle() end
    end
	end
end

function onbuiltentity(event)
  if event.createdentity.name == "mjollnir" then
    event.createdentity.destroy()
		game.player.insert({name="mjollnir", count=1})
    return
	elseif glob.restore then
		restore(event.createdentity.name)
	end
end

function onputitem(event)
	if isHolding({name="mjollnir", count=1}) then
		if glob.toolmode == "resource" then
			makeInfResource(event.position)
		elseif glob.toolmode == "teleport" then
			moveFast(event.position)
		elseif glob.toolmode == "cleaner" then
			clearArea(event.position)
    elseif glob.toolmode == "filler" then
      fillSelected()
		end
	end
end

function makeInfResource(pos)
	if glob.tick ~= nil and glob.tick > game.tick then return end
  glob.tick = game.tick + 2

	local entity = game.player.selected
	if entity and entity.valid and entity.type == "resource" then -- edits found resource
		entity.amount = -1
		game.createentity({name="huge-lightning", position=entity.position})

		spawnsparkle(entity.position)
		spawnsparkle(entity.position)
		spawnsparkle(entity.position)
    
	elseif game.canplaceentity({name=glob.oretype, position=pos}) then -- makes new resource
		game.createentity({name=glob.oretype, position=pos, amount = -1})
		game.createentity({name="huge-lightning", position=pos})

		spawnsparkle(pos)
		spawnsparkle(pos)
		spawnsparkle(pos)
	end
end

function spawnsparkle(pos)
	game.createentity({name="sparkle", position=pos, movement={ math.random(11)/20-0.225, math.random(11)/20-0.225 }, height=1, vertical_speed=0.3, frame_speed=0})
end

function moveFast(targetpos)
	if glob.tick ~= nil and glob.tick > game.tick then return end
	glob.tick = game.tick + 2
    
	local divider = 5 -- 100% / divider. For tuning movement speed
	local startpos = game.player.position
	local vector = deductPos(targetpos, startpos)
	local magnitude = (vector.x^2+vector.y^2)^0.5
	vector = {x=vector.x/divider, y=vector.y/divider}
	local telepos = addPos(startpos,vector)
	if glob.teleport.avoid and not game.canplaceentity({name="player", position=telepos}) then return end
	game.player.teleport(telepos)
end

function clearArea(pos)
	if glob.tick ~= nil and glob.tick > game.tick then return end
	glob.tick = game.tick + 2
    
	if glob.cleanerpos == nil then
		glob.cleanerpos = pos
	elseif glob.cleanerpos.x == pos.x and glob.cleanerpos.y == pos.y then
		glob.cleanerpos = nil
	else
		local entities = game.findentities{{math.min(glob.cleanerpos.x,pos.x),math.min(glob.cleanerpos.y,pos.y)},
						{math.max(glob.cleanerpos.x,pos.x),math.max(glob.cleanerpos.y,pos.y)}}
		for _, entity in pairs(entities) do
			if entity.type ~= "player" and entity.type ~= "explosion" and entity.type ~= "smoke" and entity.type ~= "arrow"
				and entity.type ~= "flying-text" and entity.type ~= "particle" then entity.destroy() end
		end
		glob.cleanerpos = nil
	end
end

function fillSelected()
  glob.fillselected = game.player.selected
  if glob.fillselected and glob.fillselected.valid then
    centerPopUp("fill")
  end
end



--
-- Script interface
--
remote.addinterface("testmode",
{
  activate = function()
		if game.player.gui.top.tm_flow == nil then
			glob.stacksize = 1
			glob.restore = false
			glob.printevents = false
			glob.timeline = "Normal"
			--Tool values
			glob.toolmode = "resource"
			glob.oretype = "iron-ore"
			glob.teleport = {avoid = false}
			

			game.player.gui.top.add({type="flow", direction="vertical", name="tm_flow"})
			game.player.gui.top.tm_flow.add({type="flow", direction="horizontal", name="toolbar"})
			game.player.gui.top.tm_flow.toolbar.add({ type="button", name="tm_b", caption="Testing mode" })
			activate()
		else
			game.alwaysday = false
			
			game.player.gui.top.tm_flow.destroy()
			game.onevent(defines.events, nil)
		end
  end,
  closePopUp = function()
    centerPopUp()
  end,
  printglob = function()
		game.showmessagedialog(serpent.line(glob))
  end
})



--
-- [2.1] Gui Functions
--
function tm_toggle()
	tmgui = game.player.gui.top.tm_flow
	if tmgui.tmframe then
		tmgui.tmframe.destroy()
		tmgui.toolbar.tm_b.destroy()
		tmgui.toolbar.add({ type="button", name="tm_b", caption="Testing mode" })
		if tmgui.toolbar.tl1 then
			show_toolbar()
			show_toolbar() --Fixing element order
		end
	else
		tmgui.add({ type="frame",direction="horizontal", name="tmframe", caption="Test mode window" })
		tmgui.tmframe.add({ type="flow", name="maintabs", direction="vertical" })
		tmgui.tmframe.maintabs.add({ type="button", name="tm_settings_b", caption="Game Settings" })
		tmgui.tmframe.maintabs.add({ type="button", name="tm_tools_b", caption="Tool Settings" })
		tmgui.tmframe.maintabs.add({ type="button", name="tm_items_b", caption="Item Lists" })
		if glob.tab_active then
			if glob.tab_active == "settings" then
				show_settings()
			elseif glob.tab_active == "tools" then
				show_tool_settings()
			else --items
				show_items()
			end
		end
	end
end

function clear_rightside()
	tmgui = game.player.gui.top.tm_flow
	if tmgui.tmframe.settings_t then tmgui.tmframe.settings_t.destroy()
	elseif tmgui.tmframe.tools_t then tmgui.tmframe.tools_t.destroy()
	elseif tmgui.tmframe.iflow then tmgui.tmframe.iflow.destroy() end
end

function make_placeholder(element,count)
	for i=1,count do
		element.add({ type="label", caption="" })
	end
end

function show_settings()
	clear_rightside()
	tmgui = game.player.gui.top.tm_flow
	tmgui.tmframe.add({ type="table", name="settings_t", colspan=6 })
	tmgui.tmframe.settings_t.add({ type="label", caption="Game Settings:" })
	make_placeholder(tmgui.tmframe.settings_t, 4)
	tmgui.tmframe.settings_t.add({ type="button", name="getalltech", caption="Get all tech", style="tm-settings-button" })

	tmgui.tmframe.settings_t.add({ type="label", caption="Item restore mode:" })
	tmgui.tmframe.settings_t.add({ type="button", name="restoretoggle", caption = glob.restore and "ON" or "OFF", style="tm-settings-button" })
	
	tmgui.tmframe.settings_t.add({ type="label", caption="Print events:" })
	tmgui.tmframe.settings_t.add({ type="button", name="eventtoggle", caption = glob.printevents and "ON" or "OFF", style="tm-settings-button" })

	tmgui.tmframe.settings_t.add({ type="label", caption="Time of day:" })
	tmgui.tmframe.settings_t.add({ type="button", name="timetoggle", caption=glob.timeline, style="tm-settings-button" })

	glob.tab_active = "settings"
end

function show_tool_settings()
	clear_rightside()
	tmgui = game.player.gui.top.tm_flow
	tmgui.tmframe.add({ type="table", name="tools_t", colspan=8 })
	tmgui.tmframe.tools_t.add({ type="label", caption="Tool Settings:" })
	make_placeholder(tmgui.tmframe.tools_t, 7)
	
	tmgui.tmframe.tools_t.add({ type="label", caption="Resource Mode:" })
	tmgui.tmframe.tools_t.add({ type="button", name="res_mode", caption=("resource"==glob.toolmode) and "ON" or "OFF", style="tm-settings-button"  })
	tmgui.tmframe.tools_t.add({ type="label", caption="Teleport Mode:" })
	tmgui.tmframe.tools_t.add({ type="button", name="tele_mode", caption=("teleport"==glob.toolmode) and "ON" or "OFF", style="tm-settings-button"  })
	tmgui.tmframe.tools_t.add({ type="label", caption="Cleaner Mode:" })
	tmgui.tmframe.tools_t.add({ type="button", name="clean_mode", caption=("cleaner"==glob.toolmode) and "ON" or "OFF", style="tm-settings-button"  })
  tmgui.tmframe.tools_t.add({ type="label", caption="Filler Mode:" })
	tmgui.tmframe.tools_t.add({ type="button", name="fill_mode", caption=("filler"==glob.toolmode) and "ON" or "OFF", style="tm-settings-button"  })

	tmgui.tmframe.tools_t.add({ type="label", caption="Iron:" })--RES
	tmgui.tmframe.tools_t.add({ type="button", name="iron-ore", caption=("iron-ore"==glob.oretype) and "ON" or "OFF", style="tm-settings-button"  })--RES
	tmgui.tmframe.tools_t.add({ type="label", caption="Avoid objects/water: " })--TELE
	tmgui.tmframe.tools_t.add({ type="button", name="avoid", caption=(glob.teleport.avoid and "ON" or "OFF"), style="tm-settings-button"  })--TELE
	make_placeholder(tmgui.tmframe.tools_t,4)
	
	tmgui.tmframe.tools_t.add({ type="label", caption="Copper:" })--RES
	tmgui.tmframe.tools_t.add({ type="button", name="copper-ore", caption=("copper-ore"==glob.oretype) and "ON" or "OFF", style="tm-settings-button"  })--RES
	make_placeholder(tmgui.tmframe.tools_t,6)
	
	tmgui.tmframe.tools_t.add({ type="label", caption="Coal:" })--RES
	tmgui.tmframe.tools_t.add({ type="button", name="coal", caption=("coal"==glob.oretype) and "ON" or "OFF", style="tm-settings-button"  })--RES
	make_placeholder(tmgui.tmframe.tools_t,6)

	
	tmgui.tmframe.tools_t.add({ type="button", name="spawn_tool", caption="Spawn Tool" })
	make_placeholder(tmgui.tmframe.tools_t,1)
	tmgui.tmframe.tools_t.add({ type="button", name="toolbar_b", caption="Show Toolbar" })
	
	glob.tab_active = "tools"
end

function show_toolbar()
	tmgui = game.player.gui.top.tm_flow
	if tmgui.toolbar.tl1 then
		tmgui.toolbar.tl1.destroy()
		tmgui.toolbar.res_mode.destroy()
		tmgui.toolbar.tl2.destroy()
		tmgui.toolbar.tele_mode.destroy()
		tmgui.toolbar.tl3.destroy()
		tmgui.toolbar.clean_mode.destroy()
    tmgui.toolbar.tl4.destroy()
		tmgui.toolbar.fill_mode.destroy()
	else
		tmgui.toolbar.add({ type="label", name="tl1", caption="Tool Modes:  Resource Mode:" })
		tmgui.toolbar.add({ type="button", name="res_mode", caption=("resource"==glob.toolmode) and "ON" or "OFF", style="tm-settings-button"  })
		tmgui.toolbar.add({ type="label", name="tl2", caption=" Teleport Mode:" })
		tmgui.toolbar.add({ type="button", name="tele_mode", caption=("teleport"==glob.toolmode) and "ON" or "OFF", style="tm-settings-button"  })
		tmgui.toolbar.add({ type="label", name="tl3", caption=" Cleaner Mode:" })
		tmgui.toolbar.add({ type="button", name="clean_mode", caption=("cleaner"==glob.toolmode) and "ON" or "OFF", style="tm-settings-button"  })
    tmgui.toolbar.add({ type="label", name="tl4", caption=" Filler Mode:" })
		tmgui.toolbar.add({ type="button", name="fill_mode", caption=("filler"==glob.toolmode) and "ON" or "OFF", style="tm-settings-button"  })
	end
end

function updateDiodes()
	tmgui = game.player.gui.top.tm_flow
	if tmgui.toolbar.tl1 then
		tmgui.toolbar.res_mode.caption = ("resource"==glob.toolmode) and "ON" or "OFF"
		tmgui.toolbar.tele_mode.caption = ("teleport"==glob.toolmode) and "ON" or "OFF"
		tmgui.toolbar.clean_mode.caption = ("cleaner"==glob.toolmode) and "ON" or "OFF"
    tmgui.toolbar.fill_mode.caption = ("filler"==glob.toolmode) and "ON" or "OFF"
	end
	if tmgui.tmframe and tmgui.tmframe.tools_t then
		tmgui.tmframe.tools_t.res_mode.caption = ("resource"==glob.toolmode) and "ON" or "OFF"
		tmgui.tmframe.tools_t.tele_mode.caption = ("teleport"==glob.toolmode) and "ON" or "OFF"
		tmgui.tmframe.tools_t.clean_mode.caption = ("cleaner"==glob.toolmode) and "ON" or "OFF"
		tmgui.tmframe.tools_t.fill_mode.caption = ("filler"==glob.toolmode) and "ON" or "OFF"
	end
	
end

function show_items()
	clear_rightside()
	tmgui = game.player.gui.top.tm_flow
	tmgui.tmframe.add({ type="flow", name="iflow", direction="vertical" })
	tmgui.tmframe.iflow.add({ type="flow", name="tabs", direction="horizontal" })
	tmgui.tmframe.iflow.tabs.add({ type="label", caption="Groups:" })
	add_groups(tmgui.tmframe.iflow.tabs)
  if glob.active_group then
    add_itemlist(glob.active_group)
  else
	  tmgui.tmframe.iflow.add({ type="table", name="itemlist_t", colspan=ITEM_COLSPAN })
	  tmgui.tmframe.iflow.itemlist_t.add({ type="label", caption="" }) --placeholder
    add_footer(tmgui.tmframe.iflow)
  end
	glob.tab_active = "items"
  
end

function add_footer(element)
	if element.footer then element.footer.destroy() end
	element.add({ type="flow", name="footer", direction="horizontal" })
	element.footer.add({ type="label", caption=" " }) --placeholder
	element.footer.add({ type="button", name="clearall", caption="Clear main inv." })
end

function toggle_restore()
	if glob.restore == nil then
		glob.restore = true
	else
		glob.restore = not glob.restore
	end

	tmgui = game.player.gui.top.tm_flow
	tmgui.tmframe.settings_t.restoretoggle.caption = glob.restore and "ON" or "OFF"
end

function toggle_events()
  if glob.printevents == nil then
	  glob.printevents = true
	else
		glob.printevents = not glob.printevents
  end
	tmgui = game.player.gui.top.tm_flow
	tmgui.tmframe.settings_t.eventtoggle.caption = glob.printevents and "ON" or "OFF"
end

function toggle_time()
	if glob.timeline == "Normal" then
		glob.timeline = "Day"
		game.alwaysday = true
	elseif glob.timeline == "Day" then
		glob.timeline = "Night"
		 game.daytime = 0.5
	else
		glob.timeline = "Normal"
		game.daytime = 0.75
		game.alwaysday = false
	end
	tmgui = game.player.gui.top.tm_flow
	tmgui.tmframe.settings_t.timetoggle.caption = glob.timeline
end
	
function add_groups(element)
	local groups = {}
	for k,v in pairs(game.itemprototypes) do
		groups[v.type] = v.type
	end
	for k,v in pairs(groups) do
		element.add({ type="button", name="tab_" .. v, caption=v })
	end
  element.add({ type="button", name="tab_search", caption="Search" })
end

function add_itemlist(typename)
  glob.active_group = typename
	tmgui = game.player.gui.top.tm_flow
  if tmgui.tmframe.iflow.itemlist_t and tmgui.tmframe.iflow.itemlist_t.valid then
    tmgui.tmframe.iflow.itemlist_t.destroy()
  end
	tmgui.tmframe.iflow.add({ type="table", name="itemlist_t", colspan=ITEM_COLSPAN })
  
  local items = {}
	for _,v in pairs(game.itemprototypes) do
    if v.type == typename then
    table.insert(items, v.name)
    end
  end
  
  table.sort(items, function(a,b) return game.getlocaliseditemname(a) < game.getlocaliseditemname(b) end)
	for _,name in ipairs(items) do
		tmgui.tmframe.iflow.itemlist_t.add({ type="button", name="insert_" .. name, style="tm-item-button", caption = game.getlocaliseditemname(name) })
	end
	
	add_footer(tmgui.tmframe.iflow)
end

function showItemSearch(key)
  --glob.active_group = typename
	tmgui = game.player.gui.top.tm_flow
  if tmgui.tmframe.iflow.itemlist_t and tmgui.tmframe.iflow.itemlist_t.valid then
    tmgui.tmframe.iflow.itemlist_t.destroy()
  end
	tmgui.tmframe.iflow.add({ type="table", name="itemlist_t", colspan=ITEM_COLSPAN })

  local items = {}
	for _,v in pairs(game.itemprototypes) do
    if game.getlocaliseditemname(v.name):lower():find(key:lower(), 1, true) then
      table.insert(items, v.name)
    end
  end
  
  table.sort(items, function(a,b) return game.getlocaliseditemname(a) < game.getlocaliseditemname(b) end)
	for _,name in ipairs(items) do
		tmgui.tmframe.iflow.itemlist_t.add({ type="button", name="insert_" .. name, style="tm-item-button", caption = game.getlocaliseditemname(name) })
	end
end

function centerPopUp(action, item)
  if action == "fill" then -- ask items used in chest filling
    fillGUI()
  elseif action == "insertion" then -- ask stacksize to be used in insertion
    glob.itemname = item
    stacksizeGUI()
  elseif action == "search" then -- ask search key for itemlist generation
    textpromptGUI()
  elseif game.player.gui.center.popup ~= nil then -- remove popup
    game.player.gui.center.popup.destroy()
    game.player.gui.center.add({ type="flow", direction="horizontal", name="popup" })
    game.player.gui.center.popup.destroy()
  end
end

function fillGUI()
	game.player.gui.center.add({ type="frame", direction="horizontal", name="popup", caption = "Fill chest with" })
	game.player.gui.center.popup.add({ type="table", name="tbl", colspan=2 })
	local guitbl = game.player.gui.center.popup.tbl
	guitbl.add({ type="button", name="fc-iron-ore", style="tm-item-button", caption = "Iron Ore" })
	guitbl.add({ type="button", name="fc-iron-plate", style="tm-item-button", caption = "Iron" })
  
	guitbl.add({ type="button", name="fc-steel-plate", style="tm-item-button", caption = "Steel" })
	guitbl.add({ type="button", name="fc-coal", style="tm-item-button", caption = "Coal" })
	
	guitbl.add({ type="button", name="fc-copper-ore", style="tm-item-button", caption = "Copper Ore" })
	guitbl.add({ type="button", name="fc-copper-plate", style="tm-item-button", caption = "Copper" })

	guitbl.add({ type="button", name="fc-stone", style="tm-item-button", caption = "Stone" })
	guitbl.add({ type="button", name="fc-stone-brick", style="tm-item-button", caption = "Bricks" })
  
	guitbl.add({ type="button", name="fc-list", style="tm-item-button", caption = "Select from list" })
	guitbl.add({ type="button", name="fc-cancel", style="tm-item-button", caption = "Cancel" })
end

function stacksizeGUI()
	game.player.gui.center.add({ type="frame", direction="horizontal", name="popup", caption = "How many?" })
	game.player.gui.center.popup.add({ type="table", name="tbl", colspan=2 })
	local guitbl = game.player.gui.center.popup.tbl
	guitbl.add({ type="textfield", name="ss-box", style="number_textfield_style", text = "1" })
	guitbl.add({ type="button", name="ss-items", style="tm-popup-button", caption = "Items" })
	guitbl.add({ type="button", name="ss-cancel", style="tm-popup-button", caption = "Cancel" })
	guitbl.add({ type="button", name="ss-stacks", style="tm-popup-button", caption = "Stacks" })
end

function textpromptGUI()
  game.player.gui.center.add({ type="frame", direction="horizontal", name="popup", caption = "Give search key" })
	game.player.gui.center.popup.add({ type="table", name="tbl", colspan=2 })
	local guitbl = game.player.gui.center.popup.tbl
	guitbl.add({ type="textfield", name="tp-box", style="number_textfield_style", text = "----" })
	guitbl.add({ type="button", name="tp-find", style="tm-popup-button", caption = "Find" })
  make_placeholder(guitbl, 1)
	guitbl.add({ type="button", name="tp-cancel", style="tm-popup-button", caption = "Cancel" })
end



--
--Utilities
--

function isHolding(stack)
  local holding = game.player.cursorstack
  if (holding.name == stack.name) and (holding.count >= stack.count) then
    return true
  end

  return false
end

function restore(item)
	local ok =pcall(function () game.player.getitemcount(item) end)
	if not glob.restore or not ok or game.player.getitemcount(item) >= 1 then return end
	game.player.insert( {name = item, count = 1} )
end

function insertstack(stack)
  if type(stack) == "number" then
    game.player.insert( {name=glob.itemname, count=stack} )
  elseif type(stack) == "table" then
    game.player.insert( {name=stack.name, count=stack.count} )
  end

end

function clearinvs()
	--game.player.getinventory(defines.inventory.playerquickbar).clear()
	game.player.getinventory(defines.inventory.playermain).clear()
	--game.player.getinventory(defines.inventory.playerguns).clear()
	--game.player.getinventory(defines.inventory.playertools).clear()
	--game.player.getinventory(defines.inventory.playerammo).clear()
	--game.player.getinventory(defines.inventory.playerarmor).clear()
end

function get_key_for_value( t, value )
  for k,v in pairs(t) do
    if v==value then return k end
  end
  return nil
end

function addPos(apos, bpos)
	if apos.x == nil then
		return {(apos[1] + bpos[1]), (apos[2] + bpos[2])}
	else
		return {x = (apos.x + bpos.x), y = (apos.y + bpos.y)}
	end
end

function deductPos(apos, bpos)
	if apos.x == nil then
		return {(apos[1] - bpos[1]), (apos[2] - bpos[2])}
	else
		return {x = (apos.x - bpos.x), y = (apos.y - bpos.y)}
	end
end
